Attribute VB_Name = "modImportazioni"
'Scopo: cercare i files contenuti in una directory e nelle sottodirectory
'       con la possibilit di utilizzare wildchars
'Condizioni d'uso: questo programma ed il codice sono Free.
'Per commenti, suggerimenti e altro scievete a elidgo@keycomm.it (Mazzaro Diego)

'Costanti per Function AllDir
Public Enum AllDir_Parameters
    AllDir_SottoDir = 1
    AllDir_SistENasc = 2
    AllDir_NomiDirectory = 4
End Enum
Public Enum AllDir_Modes
    AllDir_Completo = 0
    AllDir_PrimoFile = 1
    AllDir_Prossimo = 2
End Enum
Private Type typDatoConPuntatore
    '*******************************************************
    '* Questo tipo di dati serve a memorizzare dati che si *
    '* puntano in modo da formare catene o anelli di dati  *
    '*******************************************************
    '++ Versione 1.0.0 ++
    '++ Ultima modifica: 04/08/1998 ++
    Valore As Variant
    Puntatore As Long
End Type
Type typBuffCirc
    '*******************************************************
    '* Questo tipo di dati memorizza e permette di leggere *
    '* dati in modo sequenziale in modo veloce             *
    '*******************************************************
    '**************************************************
    'Tipi di dati richiesti:
    '-- typDatoConPuntatore
    '**************************************************
    '++ Versione 1.0.0 ++
    '++ Ultima modifica: 04/09/1998 ++
    Dato() As typDatoConPuntatore
    UltimaLettura As Long
    UltimaScrittura As Long
End Type
Private Sub ScriviSuBuffCirc(Dato As Variant, BufferCircolare As typBuffCirc)
    '**************************************************************
    '* Questa sub serve a scrivere un dato in un buffer circolare *
    '**************************************************************
    '**************************************************
    'Tipi di dati richiesti:
    '-- typBuffCirc
    '**************************************************
    '++ Versione 1.0.0 ++
    '++ Ultima modifica: 04/09/1998 ++
    Dim ProssimaScrittura As Long
    With BufferCircolare
        ProssimaScrittura = .Dato(.UltimaScrittura).Puntatore
        If ProssimaScrittura <> .Dato(.UltimaLettura).Puntatore Or IsEmpty(.Dato(ProssimaScrittura).Valore) Then
            .Dato(ProssimaScrittura).Valore = Dato
            .UltimaScrittura = ProssimaScrittura
        Else
            ReDim Preserve .Dato(1 To UBound(.Dato) + 1)
            .Dato(UBound(.Dato)).Valore = Dato
            .Dato(UBound(.Dato)).Puntatore = ProssimaScrittura
            .Dato(.UltimaScrittura).Puntatore = UBound(.Dato)
            .UltimaScrittura = UBound(.Dato)
            .UltimaLettura = .UltimaScrittura
        End If
    End With
End Sub
Public Sub AllDir(Percorso As String, NomeFile As String, Parametri As AllDir_Parameters, Risultato() As String, Optional Modo As AllDir_Modes = AllDir_Completo)
    '*********************************************************
    '* Questa funzione restituisce i nomi dei file contenuti *
    '* in una directory che corrispondono a "NomeFile"       *
    '*********************************************************
    '**************************************************
    'Procedure e funzioni richieste:
    '-- ResettaBuffCirc
    '-- ScriviSuBuffCirc
    '-- LeggiDaBuffCirc
    '-- WildCharsOk
    'Tipi di dati richiesti:
    '-- typBuffCirc
    '**************************************************
    '++ Versione 2.1.4 ++
    '++ Ultima modifica: 03/07/1999 ++
    Static Directory As typBuffCirc, AttDir As String 'L'elenco delle Dir da esplorare e il nome della Dir attuale
    Static Finito As Boolean, Inizializza As Boolean  'Indicano se la ricerca  finita e se  necessario reinizializzare 'Dir'
    Static Temp As String                             'Il valore restituito da 'Dir'
    Static NumFile As Long                            'Il numero di file trovati
    If Parametri > 7 Or Parametri < 0 Or Modo > 2 Or Modo < 0 Then
        Err.Clear                                       'Con questi due If .. Then
        Err.Raise 5                                     'controllo se i parametri passati sono giusti
        Exit Sub
    End If
    If Modo = AllDir_Completo Or Modo = AllDir_PrimoFile Then
        NumFile = 0
        Inizializza = True
        AttDir = ""
        ResettaBuffCirc Directory
        ReDim Risultato(0)
    End If
    If Right(Percorso, 1) = "\" Then Percorso = Left(Percorso, Len(Percorso) - 1) 'Tolgo l'eventuale '\' dal percorso
    Finito = False
    Do
        If Inizializza Then 'Se devo inizializzare la funzione Dir di VB
            Temp = Dir(Percorso + AttDir + "\*.*", vbDirectory * Abs(CInt(CBool(Parametri And (AllDir_SottoDir Or AllDir_NomiDirectory)))) + (vbHidden + vbSystem) * Abs(CInt(CBool(Parametri And AllDir_SistENasc))))
            Inizializza = False
        Else
            Temp = Dir
        End If
        If Temp <> "" Then 'Se la Dir ha restituito qualche cosa...
            If CBool(GetAttr(Percorso + AttDir + "\" + Temp) And vbDirectory) Then 'Se  una directory...
                If Temp <> ".." And Temp <> "." Then '... e non  "." o ".."
                    'Se voglio cercare anche nelle sottodirectory la metto nel Buffer
                    If CBool(Parametri And AllDir_SottoDir) Then ScriviSuBuffCirc AttDir + "\" + Temp, Directory
                    'Se voglio visualizzare anche le directory e il nome corrisponde ai WildChars...
                    If CBool(Parametri And AllDir_NomiDirectory) And WildCharsOk(Temp, NomeFile) Then
                        If Modo = AllDir_Completo Then 'se si  scelta la modalit Completo...
                            NumFile = NumFile + 1
                            ReDim Preserve Risultato(NumFile) '...creo un nuovo elemento dell'array...
                            Risultato(NumFile) = AttDir + "\" + Temp '...e ci metto il mio file
                        Else '...altrimenti...
                            Risultato(0) = AttDir + "\" + Temp '...metto il file su Risultato(0)...
                            Finito = True                      '...e finisco.
                        End If
                    End If
                End If
            ElseIf WildCharsOk(Temp, NomeFile) Then 'se invece si tratta di un file controllo i WildChars...
                If Modo = AllDir_Completo Then      '...e restituisco il nome come prima
                    NumFile = NumFile + 1
                    ReDim Preserve Risultato(NumFile)
                    Risultato(NumFile) = AttDir + "\" + Temp
                Else
                    Risultato(0) = AttDir + "\" + Temp
                    Finito = True
                End If
            End If
        Else 'se 'Dir' restituisce ""...
            If CBool(Parametri And AllDir_SottoDir) Then '...se voglio cercare nelle sottodirectory...
                AttDir = LeggiDaBuffCirc(Directory) '...leggo la prossima sottodir dal Buffer...
                Inizializza = True                  '...e provvedo a reinizializzare la 'Dir'
            End If
            If AttDir = "" Then 'Se anche le directory sono finite
                Finito = True   'Il lavoro  concluso
                Risultato(0) = ""
            End If
        End If
    Loop Until Finito
    If Modo = AllDir_Completo Then 'per liberare memoria visto che sono Static
        Erase Directory.Dato
        AttDir = ""
        Temp = ""
    End If
End Sub
Private Sub ResettaBuffCirc(BufferCircolare As typBuffCirc)
    '****************************************************
    '* Questa sub serve a resettare un buffer circolare *
    '* e preparalo all'immisione di nuovi dati          *
    '****************************************************
    'Tipi di dati richiesti:
    '-- typBuffCirc
    '**************************************************
    '++ Versione 1.0.0 ++
    '++ Ultima modifica: 04/09/1998 ++
    With BufferCircolare
        ReDim .Dato(1 To 1)
        .Dato(1).Puntatore = 1
        .Dato(1).Valore = Empty
        .UltimaLettura = 1
        .UltimaScrittura = 1
    End With
End Sub
Private Function LeggiDaBuffCirc(BufferCircolare As typBuffCirc) As Variant
    '******************************************************************
    '* Questa funzione serve a leggere un dato da un buffer circolare *
    '******************************************************************
    '**************************************************
    'Tipi di dati richiesti:
    '-- typBuffCirc
    '**************************************************
    '++ Versione 1.0.0 ++
    '++ Ultima modifica: 04/09/1998 ++
    Dim Lettura As Long
    With BufferCircolare
        Lettura = .Dato(.UltimaLettura).Puntatore
        LeggiDaBuffCirc = .Dato(Lettura).Valore
        If Lettura = UBound(.Dato) And UBound(.Dato) <> 1 Then
            .Dato(.UltimaLettura).Puntatore = .Dato(Lettura).Puntatore
            If .UltimaScrittura = Lettura Then .UltimaScrittura = .UltimaLettura
            ReDim Preserve .Dato(1 To UBound(.Dato) - 1)
        Else
            .Dato(Lettura).Valore = Empty
            .UltimaLettura = Lettura
        End If
    End With
End Function
Public Function WildCharsOk(Nome As String, Spec As String) As Boolean
    '***************************************************
    '* Questa funzione controlla se il nome di un file *
    '* rispetta una specifica con eventuali WildChars  *
    '***************************************************
    '++ Versione 1.0.3 ++
    '++ Ultima modifica: 03/07/1999 ++
    Dim Temp As String
    Dim c As Long, Pos As Long, LN As Long, LS As Long
    Dim Inizio As Long, TempRes As Boolean
    WildCharsOk = True
    If Spec <> "*" And Spec <> "*.*" Then 'In questi casi va bene tutto
        Nome = UCase(Nome)
        Spec = UCase(Spec)
        For c = Len(Spec) - 1 To 1 Step -1 'elimino i doppi asterischi
            If Mid(Spec, c, 2) = "**" Then Spec = Left(Spec, c) + Right(Spec, Len(Spec) - c - 1)
        Next c
        LN = Len(Nome)
        LS = Len(Spec)
        Pos = 1
        For c = 1 To LS 'considero Spec e...
            Temp = Mid(Spec, c, 1) '...un carattere alla volta...
            If Temp = "?" Then     '...se  un ?...
                If Pos <= LN Then   '...e Pos  ancora all'interno di Nome...
                    Pos = Pos + 1  '...mi sposto di un carattere anche in Nome
                Else            'se invece Nome  finito e io cercavo un altro carattere...
                    WildCharsOk = False '...significa che Nome non va bene
                    Exit Function
                End If
            ElseIf Temp = "*" Then 'se invece  un *...
                If c < LS Then '...e non  l'ultimo carattere...
                    TempRes = False
                    Inizio = Pos - 1
                    Do '...controllo se una parte della parte di Nome non ancora controllata corrisponde alla parte di Spec non ancora considerata...
                        Inizio = InStr(Inizio + 1, Nome, Mid(Spec, c + 1, 1))
                        TempRes = TempRes Or WildCharsOk(Right(Nome, LN - Inizio + 1), Right(Spec, LS - c))
                    Loop Until Inizio = 0
                    If TempRes = False Then '...se ci non succede...
                        WildCharsOk = False '...significa che Nome non va bene
                    End If
                    Exit Function
                End If
            Else 'se infine non  ne ? ne *...
                If Mid(Nome, Pos, 1) <> Temp Then 'se non corrisponde con il rispettivo carattere di Nome...
                    WildCharsOk = False '...Nome non  valido
                    Exit Function
                End If
                Pos = Pos + 1 'Se corrisponde mi sposto di un carattere in Nome
            End If
        Next c
        'Se poi Nome non  finito posso accettarlo solo se Spec finiva con un *
        If Pos <= LN And Temp <> "*" Then WildCharsOk = False
    End If
End Function
